
          %----------------------%
\chapter{~~Grid meshes; patchwork}\label{\numb section 2}
          %----------------------%

This section describes several examples of ``grid'' meshes, some of them built on specific manifolds.
Note that in this manual we use the term ``manifold'' to mean a manifold without boundary.
By ``grid'' mesh we mean a regular, repetitive, mesh, often called ``structured mesh''.
It is built by a {\small\tt\verm{Mesh}::Build}\,er declared with {\small\tt\taag::grid}.
It could be made of segments, triangles, quadrilaterals or parallelipipeds;
the user provides this information through the method {\small\tt shape} of the mesh builder.

Domains with more complex shapes can be meshed by joining together several structured meshes,
like patches, using a {\small\tt\verm{Mesh}::Build}\,er with {\small\tt\taag::join}.
In contrast, section \ref{\numb section 3} shows how to mesh regions of a manifold
by propagating a front and progressively adding cells, one by one.

Paragraphs \ref{\numb section 2.\numb parag 6} and \ref{\numb section 2.\numb parag 7}
deal with one-dimensional meshes (curves) in $ \mathbb{R}^2 $,
paragraphs \ref{\numb section 2.\numb parag 17}, \ref{\numb section 2.\numb parag 20} and
\ref{\numb section 2.\numb parag 21} show curves in $ \mathbb{R}^3 $,
paragraphs \ref{\numb section 2.\numb parag 1}, \ref{\numb section 2.\numb parag 2},
\ref{\numb section 2.\numb parag 5}, \ref{\numb section 2.\numb parag 11},
\ref{\numb section 2.\numb parag 12} and \ref{\numb section 2.\numb parag 13} show plane domains
(two-dimensional meshes in $ \mathbb{R}^2 $),
while paragraphs \ref{\numb section 2.\numb parag 8}, \ref{\numb section 2.\numb parag 9},
\ref{\numb section 2.\numb parag 10}, \ref{\numb section 2.\numb parag 16},
\ref{\numb section 2.\numb parag 19}, \ref{\numb section 2.\numb parag 22} and
\ref{\numb section 2.\numb parag 24} focus on two-dimensional meshes
in $ \mathbb{R}^3 $ (surfaces).
Paragraphs \ref{\numb section 2.\numb parag 15}, \ref{\numb section 2.\numb parag 18}
and \ref{\numb section 2.\numb parag 23} show volumic meshes, made of cubic cells.

Paragraphs \ref{\numb section 2.\numb parag 6}\,--\,\ref{\numb section 2.\numb parag 19}
are about manifolds defined implicitly as level sets;
paragraphs \ref{\numb section 2.\numb parag 20}\,--\,\ref{\numb section 2.\numb parag 24}
describe parametric manifolds.


          %----------------%
\section{~~Joining segments}\label{\numb section 2.\numb parag 1}
          %----------------%

Here is another way of meshing the same L-shaped domain as in paragraph
\ref{\numb section 1.\numb parag 4}\,:

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \psfrag{G}{\small\tt\textcolor{textindraw}{G}}
  \psfrag{H}{\small\tt\textcolor{textindraw}{H}}
  \includegraphics[width=100mm]{L-shaped-distorted}
  \caption{an L-shaped mesh again}
  \label{\numb section 2.\numb fig 1}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 1}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{AG} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( G ) .divided_in ( \laranja{22} );
   \verm{Mesh} \azul{GH} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( G ) .stop_at ( H ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{HC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( H ) .stop_at ( C ) .divided_in ( \laranja{12} );
   \verm{Mesh} \azul{CD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( D ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{HD} = \verm{Mesh}::Build ( \taag::join ) .mesh ( HC ) .mesh ( CD );
   \verm{Mesh} \azul{DA} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( D ) .stop_at ( A ) .divided_in ( \laranja{8} );
   \verm{Mesh} \azul{CE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( E ) .divided_in ( \laranja{7} );
   \verm{Mesh} \azul{EF} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( F ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{FD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( F ) .stop_at ( D ) .divided_in ( \laranja{7} );
   \verm{Mesh} \azul{AGHD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( AG, GH, HD, DA );
   \verm{Mesh} \azul{CEFD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( CE, EF, FD, CD .reverse() );
   \verm{Mesh} \azul{L_shaped} = \verm{Mesh}::Build ( \taag::join ) .mesh ( AGHD ) .mesh ( CEFD );
\end{Verbatim}

The only difference between this mesh and the one presented in paragraph
\ref{\numb section 1.\numb parag 4} is a slight distortion in the lower half of the domain,
due to the non-uniform distribution of the vertices along {\small\tt HD}.

Paragraph \ref{\numb section 12.\numb parag 2} explains the coloring conventions used in
this manual for {\tt C++} code.
Paragraph \ref{\numb section 12.\numb parag 3} gives details about {\small\tt\taag}\hglue0.5pt s.


          %---------%
\section{~~Exercise}\label{\numb section 2.\numb parag 2}
          %---------%

Build the mesh shown in figure \ref{\numb section 2.\numb fig 2}.
We ask for one connected mesh, that is, the triangle and the rectangle must share some vertices
(and segments, reversed).

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \psfrag{G}{\small\tt\textcolor{textindraw}{G}}
  \psfrag{H}{\small\tt\textcolor{textindraw}{H}}
  \includegraphics[width=130mm]{arrow}
  \caption{an arrow}
  \label{\numb section 2.\numb fig 2}
\end{figure}


          %-------------%
\section{~~Joining boxes}\label{\numb section 2.\numb parag 3}
          %-------------%

In this paragraph we build a parallelipiped made of nine parts.
Paragraph \ref{\numb section 1.\numb parag 7} describes the constructor of individual parallelipipeds.
Here the upper part touches four other parts, so we need to join some segments and also some rectangles.

For the final mesh made of cubic cells, if we merely join these nine parallelipipeds,
we get a mesh which is indistinguishable from one large parallelipiped.
In order to keep track of the nine parts composing the large box and obtain the colorful drawing
in figure \ref{\numb section 2.\numb fig 3}, we use a more advanced feature\,:
a {\small\tt\verm{Mesh}::Composite} object, described in section \ref{\numb section 5}.

\begin{figure}[ht] \centering
  \includegraphics[width=85mm]{nine-boxes}
  \caption{nine boxes}
  \label{\numb section 2.\numb fig 3}
\end{figure}


          %-----------------------------------------------%
\section{~~Irregular distribution of vertices on the sides}\label{\numb section 2.\numb parag 4}
          %-----------------------------------------------%

{\small\tt\verm{Mesh}::Build}\,ers with {\small\tt\taag::grid} may produce unexpected results,
for instance if the distribution of vertices along the sides provided by the user is too irregular.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \includegraphics[width=95mm]{rectangle-non-unif-intended}
  \caption{the user wants to refine the mesh in a corner}
  \label{\numb section 2.\numb fig 4}
\end{figure}

Figure \ref{\numb section 2.\numb fig 4} shows the user's intention while figure
\ref{\numb section 2.\numb fig 5} shows the mesh produced by a statement like

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 4}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Mesh} \azul{ABCD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( AB, BC, CD, DA );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \includegraphics[width=95mm]{rectangle-irregular}
  \caption{distorted mesh}
  \label{\numb section 2.\numb fig 5}
\end{figure}

Meshes like the one shown in figure \ref{\numb section 2.\numb fig 4} can be obtained by extrusion,
see paragraph \ref{\numb section 4.\numb parag 2}.


          %-------------------------------%
\section{~~Triangular meshes on rectangles}\label{\numb section 2.\numb parag 5}
          %-------------------------------%

On a rectangular domain, we can build a mesh of triangles by invoking the method
{\small\tt with\_\,triangles} of the {\small\tt\verm{Mesh}::Build}\,er.
For instance, in example \ref{\numb section 1.\numb parag 4},
if we re-write the definition of {\small\tt BGHC} as

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{BGHC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( BG, GH, HC, BC .reverse() ) .with_triangles();
\end{Verbatim}

\noindent we get the mesh shown in figure \ref{\numb section 2.\numb fig 6}.

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{F}{\small\tt\textcolor{textindraw}{F}}
  \psfrag{G}{\small\tt\textcolor{textindraw}{G}}
  \psfrag{H}{\small\tt\textcolor{textindraw}{H}}
  \includegraphics[width=100mm]{L-shaped-tri}
  \caption{an L-shaped mesh with triangular cells}
  \label{\numb section 2.\numb fig 6}
\end{figure}

If we give the sides of the rectangle in a different order, like in

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{BGHC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( GH, HC, BC .reverse(), BG ) .with_triangles();
\end{Verbatim}

\noindent the rectangles will be cut along the other diagonal (check it yourself).

The mesh in paragraph \ref{\numb section 1.\numb parag 5} could have been built like this\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{ABD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( AB, BD, AD .reverse() );
   \verm{Mesh} \azul{BCED} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( CE, ED, BD .reverse(), BC ) .with_triangles();
   \verm{Mesh} \azul{one_tri_one_rect} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ ABD, BCED \} );
\end{Verbatim}


          %-----------------------------------------------------%
\section{~~A manifold defined as a level set in $ \mathbb{R}^2 $}
          %-----------------------------------------------------%
\label{\numb section 2.\numb parag 6}

{\ManiFEM} allows one to define manifolds and submanifolds, and this feature may be
used to build domains of the desired shape.

Until now, we have only met the trivial Euclidian manifold, defined as {\small\tt
\verm{Manifold}\break ( \taag::Euclid,} {\small\tt\taag::of\_\,dim,}
{\small\tt d} {\small\tt )}.
One can define a submanifold in terms of an implicit equation, that is, as a level set,
using the method {\small\tt implicit} of the Euclidian manifold.
The code below introduces a one-dimensional submanifold of $ \mathbb{R}^2 $ (a hiperbola).

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 6}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];

   \verm{Manifold} \azul{hiperbola} = RR2 .implicit ( x*y == \laranja{1.} );
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{0.5};   y(A) = \laranja{2.};
   \verm{Cell} \azul{B} ( \taag::vertex );  x(B) = \laranja{3.};    y(B) = \laranja{0.333333333333};

   \verm{Mesh} \azul{arc_of_hiperbola} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{7} );

   arc_of_hiperbola .export_to_file ( \taag::eps, \verde{"hiperbola.eps"} );
   arc_of_hiperbola .export_to_file ( \taag::gmsh, \verde{"hiperbola.msh"} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \includegraphics[width=85mm]{hiperbola}
  \caption{an arc of hiperbola}
  \label{\numb section 2.\numb fig 7}
\end{figure}

In {\small\tt gmsh}, you must select {\small\tt Tools} $\to$ {\small\tt Options} $\to$
{\small\tt Mesh} $\to$ {\small\tt 1D elements} in order to see this mesh.

In {\maniFEM} there is a global variable {\small\tt\verm{Manifold}::working}.
Any {\small\tt\verm{Manifold}} constructor sets this variable to the manifold
being defined.
Subsequently, most {\small\tt\verm{Mesh}::Build}\,ers, when creating inner vertices,
define their geometric coordinates by
% interpolating coordinates of vertices on the boundary of the mesh and then
projecting them on the current working manifold.
The projection operation is a method of the {\small\tt\verm{Manifold}} itself.
It does nothig for a Euclidian manifold.
For an implicit manifold, it applies a few steps of a Newton-type algorithm;
details are presented in paragraph \ref{\numb section 8.\numb parag 1}.

Note that the vertices are not perfectly uniformly distributed along the curve
because they are obtained as projections of points uniformly distributed along
the straight segment {\small\tt AB} onto the {\small\tt hiperbola} manifold.
Paragraph \ref{\numb section 3.\numb parag 5} shows another way of meshing a curve,
producing equidistant vertices.

Note also that when defining individual points {\small\tt A} and {\small\tt B} we must
be careful to set coordinates {\small\tt x} and {\small\tt y} within
the {\small\tt hiperbola} manifold.
As an alternative, we might explicitly project them onto the {\small\tt hiperbola} like this\,:
\vskip -8pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Cell} \azul{P} ( \taag::vertex );  x(P) = \laranja{0.6};  y(P) = \laranja{2.1};
   hiperbola .project (P);
\end{Verbatim}
\vskip -8pt

There is also a {\small\tt\verm{Cell}} constructor with {\small\tt\taag::of\_\,coords}
and {\small\tt\taag::project}.
This constructor first sets the values of {\small\tt x} and {\small\tt y} and then performs,
behind the curtains, a projection on the current working {\small\tt\verm{Manifold}}\,:
\vskip -8pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Cell} \azul{P} ( \taag::vertex, \taag::of_coords, \{ \laranja{0.6}, \laranja{2.1} \}, \taag::project );
\end{Verbatim}
\vskip -8pt

Also, the {\small\tt\verm{Mesh}::Build}\,er with {\small\tt .shape} {\small\tt(} 
{\small\tt\taag::segment} {\small\tt)} creates points in the surrounding space {\small\tt RR2}
and then projects them onto the {\small\tt hiperbola} without the user's assistance.


          %----------------------------------------%
\section{~~A circle defined by four curved segments}\label{\numb section 2.\numb parag 7}
          %----------------------------------------%

We can define several arcs of curve and {\small\tt join} them, thus obtaining a closed curve\,:
\medskip

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 7}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{circle_manif} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   
   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};  y(S) = \laranja{-1.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};

   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{5} );

   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ NW, WS, SE, EN \} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=60mm]{circle}
  \caption{a circle obtained by {\small\tt join}ing four segments}
  \label{\numb section 2.\numb fig 8}
\end{figure}

Again, the distribution of vertices along the circle is not perfect
because vertices are obtained as projections (on the circle) of points
along straight segments {\small\tt NW}, {\small\tt WS} and so forth.
Paragraphs \ref{\numb section 2.\numb parag 21}, \ref{\numb section 3.\numb parag 2}
and \ref{\numb section 7.\numb parag 2} show other ways of meshing a circle,
producing equidistant vertices.

Note that using a {\small\tt\verm{Mesh}::Build} {\small\tt(} {\small\tt\taag::join} {\small\tt)}
object to join four segments is very different from applying a {\small\tt\verm{Mesh}::Build}
{\small\tt(} {\small\tt\taag::grid} {\small\tt)} object with {\small\tt.shape} {\small\tt(}
{\small\tt\small\tt\taag::quadrangle} {\small\tt)} to the same four segments;
see paragraphs \ref{\numb section 2.\numb parag 11} and \ref{\numb section 2.\numb parag 13}.


          %---------------------------------------------%
\section{~~A hemisphere defined by four curved triangles}\label{\numb section 2.\numb parag 8}
          %---------------------------------------------%

In this paragraph, we mesh a surface in $ \mathbb{R}^3 $\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];
   \verm{Manifold} \azul{sphere} = RR3 .implicit ( x*x + y*y + z*z == \laranja{1.} );

   \cinza{// let's mesh half of a sphere}
   \verm{Cell} \azul{E}  ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};  z(E) = \laranja{0.};
   \verm{Cell} \azul{N}  ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};  z(N) = \laranja{0.};
   \verm{Cell} \azul{W}  ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};  z(W) = \laranja{0.};
   \verm{Cell} \azul{S}  ( \taag::vertex );  x(W) =  \laranja{0.};  y(W) = \laranja{-1.};  z(W) = \laranja{0.};
   \verm{Cell} \azul{up} ( \taag::vertex );  x(up)=  \laranja{0.};  y(up)=  \laranja{0.};  z(up)= \laranja{1.};
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \psfrag{up}{\small\tt\textcolor{textindraw}{up}}
  \includegraphics[width=95mm]{hemisphere}
  \caption{a hemisphere obtained by {\small\tt join}ing four triangles}
  \label{\numb section 2.\numb fig 9}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 8}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   int \azul{n} = \laranja{15};
   \verm{Mesh} \azul{EN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( N ) .divided_in ( n );
   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( n );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( n );
   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( n );
   \verm{Mesh} \azul{upE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( up ) .stop_at ( E ) .divided_in ( n );
   \verm{Mesh} \azul{upN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( up ) .stop_at ( N ) .divided_in ( n );
   \verm{Mesh} \azul{upW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( up ) .stop_at ( W ) .divided_in ( n );
   \verm{Mesh} \azul{upS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( up ) .stop_at ( S ) .divided_in ( n );

   \cinza{// build four triangles}
   \verm{Mesh} \azul{ENup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( EN, upN .reverse(), upE );
   \verm{Mesh} \azul{NWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( NW, upW .reverse(), upN );
   \verm{Mesh} \azul{WSup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( WS, upS .reverse(), upW );
   \verm{Mesh} \azul{SEup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( SE, upE .reverse(), upS );
   \cinza{// and finally join the triangles :}
   \verm{Mesh} \azul{hemisphere} = \verm{Mesh}::Build ( \taag::join )
      .meshes ( \{ ENup, NWup, WSup, SEup \} );
\end{Verbatim}

Again, when we define individual points {\small\tt\azul E}, {\small\tt\azul N}, {\small\tt\azul W},
{\small\tt\azul S} and {\small\tt\azul{up}} we must be careful to provide coordinates on the
{\small\tt sphere} (or {\small\tt project} them explicitly as shown in paragraph
\ref{\numb section 2.\numb parag 9}).
In contrast, a {\small\tt\verm{Mesh}::Build} {\small\tt(} {\small\tt\taag::grid} {\small\tt)}
object places inner vertices in the surrounding space ($ \mathbb{R}^2 $ or $ \mathbb{R}^3 $) and
then projects them onto the current manifold without the user's assistance (paragraph
\ref{\numb section 8.\numb parag 1} describes this projection operation).
As a side effect, within each triangle ({\small\tt ENup}, {\small\tt NWup} and so forth),
the distribution of the vertices is not perfectly uniform.

Note that, when we build the segments {\small\tt WS}, {\small\tt upS} and so on,
we know that those segments will be (polygonal approximations of) arcs of circle on the sphere.
This is so due to the particular geometry of our manifold (we know that the projection of
a straight line segment on the sphere is an arc of circle of radius equal to the radius of
the sphere); the shape of such segments is less clear in other examples
(like the one in paragraph \ref{\numb section 2.\numb parag 9}).

Section \ref{\numb section 3} shows how to mesh a surface through frontal mesh generation.


          %----------------------%
\section{~~A more complex surface}\label{\numb section 2.\numb parag 9}
          %----------------------%

If the surface is more ``bumpy'',
% since the projection operation doesn't work well for points far from the manifold,
we must use smaller patches in order to get a mesh of good quality.
Below we use twelve rectangles to get a bumpy hemisphere,
shown in figure \ref{\numb section 2.\numb fig 10}.
\vskip 15pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 9}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                             ]
   \verm{Manifold} nut = RR3 .implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );

   \verm{Cell} \azul{S} ( \taag::vertex );   x(S)  =  \laranja{0.};  y(S)  = \laranja{-1.};  z(S)  =  \laranja{0.};
   \verm{Cell} \azul{E} ( \taag::vertex );   x(E)  =  \laranja{1.};  y(E)  =  \laranja{0.};  z(E)  =  \laranja{0.};
   \verm{Cell} \azul{N} ( \taag::vertex );   x(N)  =  \laranja{0.};  y(N)  =  \laranja{1.};  z(N)  =  \laranja{0.};
   \verm{Cell} \azul{W} ( \taag::vertex );   x(W)  = \laranja{-1.};  y(W)  =  \laranja{0.};  z(W)  =  \laranja{0.};
   \verm{Cell} \azul{up} ( \taag::vertex );  x(up) =  \laranja{0.};  y(up) =  \laranja{0.};  z(up) =  \laranja{1.};
   \cinza{// no need to project these}

   \verm{Cell} \azul{mSW} ( \taag::vertex );  x (mSW) = \laranja{-1.};   y (mSW) = \laranja{-1.};   z (mSW) = \laranja{0.};
   nut .project ( mSW );  \cinza{// midway between S and W}
   \verm{Cell} \azul{mSup}  ( \taag::vertex );  x (mSup) =  \laranja{0.};   y (mSup) = \laranja{-1.};   z (mSup) = \laranja{1.};
   nut .project ( mSup );  \cinza{// midway between S and up}
   \verm{Cell} \azul{mSWup} ( \taag::vertex );  x (mSWup) = \laranja{-1.};  y (mSWup) = \laranja{-1.};  z (mSWup) = \laranja{1.};
   nut .project ( mSWup );  \cinza{// somewhere between S, W and up}
   \cinza{// ... and so forth ...}

   \cinza{// now build segments :}
   int \azul{n} = \laranja{10};
   \verm{Mesh} \azul{W_mSW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( mSW ) .divided_in ( n );
   \verm{Mesh} \azul{W_mNW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( mNW ) .divided_in ( n );
   \verm{Mesh} \azul{W_mWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( mWup ) .divided_in ( n );
   \verm{Mesh} \azul{S_mSW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( mSW ) .divided_in ( n );
   \verm{Mesh} \azul{mSW_mSWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( mSW ) .stop_at ( mSWup ) .divided_in ( n );
   \cinza{// ... and so forth ...}

   \cinza{// now the twelve rectangles :}
   \verm{Mesh} \azul{rect_W_SW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( mSW_mSWup, mWup_mSWup .reverse(), W_mWup .reverse(), W_mSW );
   \verm{Mesh} \azul{rect_S_SW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( mSup_mSWup, mSW_mSWup .reverse(), S_mSW .reverse(), S_mSup );
   \verm{Mesh} \azul{rect_up_SW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( mWup_mSWup, mSup_mSWup .reverse(), up_mSup .reverse(), up_mWup );
   \cinza{// ... and so forth ...}

   \cinza{// and finally join the rectangles :}
   \verm{Mesh} \azul{hemisphere} = \verm{Mesh}::Build ( \taag::join )
      .meshes ( \{ rect_E_NE, rect_E_SE, rect_S_SE, rect_S_SW,
                  rect_W_SW, rect_W_NW, rect_N_NE, rect_N_NW,
                  rect_up_SE, rect_up_SW, rect_up_NE, rect_up_NW \} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \psfrag{mWS}{\small\tt\textcolor{textindraw}{mSW}}
  \psfrag{mSE}{\small\tt\textcolor{textindraw}{mSE}}
  \psfrag{mWup}{\small\tt\textcolor{textindraw}{mWup}}
  \psfrag{mSup}{\small\tt\textcolor{textindraw}{mSup}}
  \psfrag{mSEup}{\small\tt\textcolor{textindraw}{mSEup}}
  \psfrag{up}{\small\tt\textcolor{textindraw}{up}}
  \psfrag{mWSup}{\small\tt\textcolor{textindraw}{mWSup}}
  \includegraphics[width=95mm]{hemisphere-2}
  \caption{here we have {\small\tt join}\,ed twelve rectangles}
  \label{\numb section 2.\numb fig 10}
\end{figure}

Unlike in paragraph \ref{\numb section 2.\numb parag 8}, here we do not control the
exact shape of the segments {\small\tt S\_\,mSW}, {\small\tt S\_\,mSup} and so on.
They are projections of straight line segments onto our surface but since the equation
of the surface is rather complicated we do not know the exact shape of these projections.
Since points like {\small\tt mSW} and {\small\tt mSE} have been placed initially in
{\small\tt RR3} not belonging to the {\small\tt bupmy} manifold and then explicitly
{\small\tt project}ed,
there is no guarantee that they lie in the plane $ z = 0 $ (they probably don't).
We notice an angle between {\small\tt W\_\,mSW} and {\small\tt S\_\,mSW} at {\small\tt mSW}.

Paragraph \ref{\numb section 2.\numb parag 19} shows a way to control the shape of the segments
{\small\tt S\_\,mSW}, {\small\tt S\_\,mSE} and so on.

Section \ref{\numb section 3} shows other ways of meshing a surface.


          %--------%
\section{~~Exercise}\label{\numb section 2.\numb parag 10}
          %--------%

Slightly change the code in paragraph \ref{\numb section 2.\numb parag 9}
in order to obtain the mesh shown in figure \ref{\numb section 2.\numb fig 11}.
(Hint: have a look at paragraph \ref{\numb section 2.\numb parag 5}.)

\begin{figure}[ht] \centering
  \includegraphics[width=85mm]{hemisphere-1}
  \caption{using triangular cells}
  \label{\numb section 2.\numb fig 11}
\end{figure}


          %-----------------------------%
\section{~~Alternating between manifolds}\label{\numb section 2.\numb parag 11}
          %-----------------------------%

Let's go back to the example in paragraph \ref{\numb section 2.\numb parag 7}.
Suppose we want to mesh the whole disk, not just its boundary.
We can build the boundary of the disk just like in paragraph
\ref{\numb section 2.\numb parag 7}, by placing ourselves in the manifold {\small\tt circle}.
But if we want to subsequently mesh the interior of the disk, we must leave {\small\tt circle}
and switch back to the original {\small\tt RR2} manifold.
Method {\small\tt set\_\,as\_\,working\_\,manifold} allows us to do that.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 11}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];
   
   \verm{Manifold} \azul{circle} = RR2 .implicit ( x*x + y*y == \laranja{1.} );
   
   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};  y(S) = \laranja{-1.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};

   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{EN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( N ) .divided_in ( \laranja{10} );
   
   RR2 .set_as_working_manifold();

   \verm{Mesh} \azul{disk} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( \{ NW, WS, SE, EN \} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=58mm]{disk}
  \caption{a disk treated as a rectangle}
  \label{\numb section 2.\numb fig 12}
\end{figure}

The mesh (shown in figure \ref{\numb section 2.\numb fig 12}) is of poor quality;
we obtain quadrilaterals having a wide angle near {\small\tt S}, {\small\tt N}, {\small\tt E}
and {\small\tt W}.
Paragraph \ref{\numb section 2.\numb parag 12} shows a better way of meshing a disk.
Paragraphs \ref{\numb section 3.\numb parag 1} and \ref{\numb section 3.\numb parag 2} show
how to mesh a disk through a frontal mesh generation algorithm.

Each time a {\small\tt\verm{Manifold}} object is created, its constructor sets it as
working manifold; this is why in many cases we don't need to know about method
{\small\tt set\_\,as\_\,working\_\,manifold}.
We need it, however, in cases like the one presented here.


          %--------%
\section{~~Exercise}\label{\numb section 2.\numb parag 12}
          %--------%

Mesh half of a disk by joining three triangular meshes,
like in figure \ref{\numb section 2.\numb fig 13}.
Mesh the entire disk by joining six triangular meshes.

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=78mm]{half-disk}
  \caption{half disk, made of three triangles}
  \label{\numb section 2.\numb fig 13}
\end{figure}


          %------------------------------------%
\section{~~Alternating between manifolds, again}\label{\numb section 2.\numb parag 13}
          %------------------------------------%

Here is an example similar to the one in paragraph \ref{\numb section 2.\numb parag 11},
this time with four arcs of hiperbola.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 13}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{xy} = RR2 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xy[\laranja{0}], \azul{y} = xy[\laranja{1}];

   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};  y(S) = \laranja{-1.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};

   \verm{Manifold} \azul{first_arc}  = RR2 .implicit ( x*y + x - y == \laranja{-1.} );
   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{10} );
   \verm{Manifold} \azul{second_arc} = RR2 .implicit ( x*y - x - y ==  \laranja{1.} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( \laranja{10} );
   \verm{Manifold} \azul{third_arc}  = RR2 .implicit ( x*y - x + y == \laranja{-1.} );
   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( \laranja{10} );
   \verm{Manifold} \azul{fourth_arc} = RR2 .implicit ( x*y + x + y ==  \laranja{1.} );
   \verm{Mesh} \azul{EN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( N ) .divided_in ( \laranja{10} );

   RR2 .set_as_working_manifold();
   \verm{Mesh} \azul{diamond} = Mesh::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( NW, WS, SE, EN );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=63mm]{diamond}
  \caption{a diamond shape}
  \label{\numb section 2.\numb fig 14}
\end{figure}

Paragraph \ref{\numb section 3.\numb parag 16} shows another way of meshing the same domain.


          %--------------------------%
\section{~~Zero-dimensional manifolds}\label{\numb section 2.\numb parag 14}
          %--------------------------%

This may sound strange, but we can define zero-dimensional manifolds and
such manifolds may even be useful.

In this paragraph, we define two parabolas, one having vertical axis and the other one with
horizontal axis.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 14}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{parab_vert}  = RR2 .implicit ( y == x * x - \laranja{2.} );
   \verm{Manifold} \azul{parab_horiz} = RR2 .implicit ( x == y * y - \laranja{2.} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \psfrag{C}{\small\tt\textcolor{textindraw}{C}}
  \psfrag{D}{\small\tt\textcolor{textindraw}{D}}
  \includegraphics[width=65mm]{two-parab}
  \caption{a curved quadrilateral}
  \label{\numb section 2.\numb fig 15}
\end{figure}

We want to mesh the region contained between these two parabolas (a curved quadrilateral).
Just like in paragraphs \ref{\numb section 2.\numb parag 11} and \ref{\numb section 2.\numb parag 13},
we must start with the four corners.
We could certainly compute their coordinates by hand, but we can also ask {\maniFEM} to do that.
We define a zero-dimensional manifold which in this case consists in four points
(the intersection between the two parabolas)\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 14}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{four_points} ( \taag::intersect, parab_vert, parab_horiz );
\end{Verbatim}

Then we build points and project them explicitly onto this manifold.
The projection will (usually) find the closest point to the given one, so we only need to define
initial coordinates in the desired zone of the plane.
Of course, it is better to give initial positions close to the desired point;
this way the projection algorithm will find more easily its target.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{-1.};  y(A) = \laranja{-1.};
   four_points .project (A);
\end{Verbatim}

Equivalently, we can use a constructor with {\small\tt\taag::of\_\,coords} and
{\small\tt\taag::project}.
This constructor first sets the values of {\small\tt x} and {\small\tt y} and then performs,
behind the curtains, a projection on the current working {\small\tt\verm{Manifold}}\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 14}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Cell} \azul{B} ( \taag::vertex, \taag::of_coords, \{ \laranja{1.}, \laranja{-1.} \}, \taag::project );
\end{Verbatim}


          %-----------------------------------%
\section{~~A three-dimensional star-like shape}\label{\numb section 2.\numb parag 15}
          %-----------------------------------%

Here is a three-dimensional version of the diamond in paragraph \ref{\numb section 2.\numb parag 13}.

In figure \ref{\numb section 2.\numb fig 16}, some layers have been removed so that the reader
can see inner cells.
This was done using the following options of {\small\tt gmsh}: {\small\tt Tools} $\to$
{\small\tt Clipping} $\to$ {\small\tt Mesh} $\to$ {\small\tt Planes} $\to$
{\small\tt Keep} {\small\tt  whole} {\small\tt  elements}, $ A = 1, B = 0.2, C = 0.3, D = 0.6 $.

Comments in paragraph \ref{\numb section 1.\numb parag 7} apply.

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=65mm]{cube-star}
  \caption{a 3D diamond}
  \label{\numb section 2.\numb fig 16}
\end{figure}

For very curved meshes, the approach described in paragraph \ref{\numb section 2.\numb parag 23}
may be better.


          %----------------%
\section{~~An organic shape}\label{\numb section 2.\numb parag 16}
          %----------------%

This paragraph describes a surface meant to mimic the shape of a physalis fruit.

%\begin{figure}[h!]\centering
%  \includegraphics[width=85mm]{empty}
%  \caption{dry physalis, with fruit inside}\label{\numb section 2.\numb fig 17}
%\end{figure}

\begin{figure}[!ht]\centering
%\vskip -3mm
\if\production 1
\centerline{\includegraphics[width=86mm]{dry-physalis}}
\else
\psfrag{photo}{[photo of a physalis]}
\centerline{\includegraphics[width=94mm]{fake-physalis}}
\fi
\caption{dry physalis, with fruit inside}\label{\numb section 2.\numb fig 17}
\end{figure}
%\vfil\eject

We begin by defining a revolution surface in $ \mathbb{R}^3 $\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Function} \azul{r2} = x*x + y*y + z*z;
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Manifold} \azul{apple} = RR3 .implicit ( \verm{power}(r2,\laranja{0.5}) * \verm{sin}(r2-pi/\laranja{6.}) == z );
\end{Verbatim}
\vskip -8pt

This surface has the shape shown in figure \ref{\numb section 2.\numb fig 18},
which does not resemble a physalis fruit.

\begin{figure}[ht] \centering
  \includegraphics[width=58mm]{fisalis-manif}
  \caption{a compact manifold resembling an apple}
  \label{\numb section 2.\numb fig 18}
\end{figure}

Instead of meshing the {\small\tt apple} surface, we just build eight curves immersed in it
(each curve joins {\small\tt A} to {\small\tt D} and is made of three shorter curves)\,:
\vskip 10pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Cell} \azul{A} ( \taag::vertex );  x(A) = \laranja{0.};  y(A) = \laranja{0.};  z(A) = std::sqrt ( \laranja{2.}*pi/\laranja{3.} );
   \verm{Cell} \azul{B1} ( \taag::vertex );  x(B1) = \laranja{1.};  y(B1) = \laranja{0.};  z(B1) = \laranja{1.};
   \verm{Cell} \azul{C1} ( \taag::vertex );  x(C1) = \laranja{1.};  y(C1) = \laranja{0.};  z(C1) = \laranja{0.};
   apple .project (B1);  apple .project (C1);
   \verm{Cell} \azul{D} ( \taag::vertex );  x(D) = \laranja{0.};  y(D) = \laranja{0.};  z(D) = \laranja{0.};
   \verm{Mesh} \azul{AB1} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B1 ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{B1C1} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B1 ) .stop_at ( C1 ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{C1D} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C1 ) .stop_at ( D ) .divided_in ( \laranja{10} );
   \cinza{// and so on ...}
\end{Verbatim}
\vskip -8pt

Then we switch back to {\small\tt RR3} (thus leaving the {\small\tt apple} manifold) and build
transversal segments, as well as triangular and quadrangular patches\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   RR3 .set_as_working_manifold();
   \verm{Mesh} \azul{B1B2} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B1 ) .stop_at ( B2 ) .divided_in ( \laranja{10} );
   \verm{Mesh} \azul{B2B3} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B2 ) .stop_at ( B3 ) .divided_in ( \laranja{10} );
   \cinza{// and many other segments ...}
   \verm{Mesh} \azul{AB1B2} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( AB1, B1B2, AB2 .reverse() );
   \verm{Mesh} \azul{AB2B3} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::triangle )
      .faces ( AB2, B2B3, AB3 .reverse() );
   \cinza{// and other triangular patches ...}
   \verm{Mesh} \azul{B1C1C2B2} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( B1C1, C1C2, B2C2 .reverse(), B1B2 .reverse() ) .with_triangles();
   \verm{Mesh} \azul{B2C2C3B3} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::quadrangle )
      .faces ( B2C2, C2C3, B3C3 .reverse(), B2B3 .reverse() ) .with_triangles();
   \cinza{// and other quadrangular patches ...}   
\end{Verbatim}

We then join all patches\,:
\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Mesh} \azul{sect1} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ AB1B2, B1C1C2B2, C1DC2 \} );
   \verm{Mesh} \azul{sect2} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ AB2B3, B2C2C3B3, C2DC3 \} );
   \cinza{// more sectors ...}
   std::vector < \verm{Mesh} > lm \{ sect1, sect2, sect3, sect4, sect5, sect6, sect7, sect8 \};
   \verm{Mesh} \azul{fisalis} = \verm{Mesh}::Build ( \taag::join ) .meshes ( lm ); 
\end{Verbatim}

\begin{figure}[ht] \centering
  \includegraphics[width=60mm]{fisalis-round}
  \caption{not yet a physalis}
  \label{\numb section 2.\numb fig 19}
\end{figure}

This shape (shown in figure \ref{\numb section 2.\numb fig 19}) is still not satisfactory,
so we apply a deformation in $ \mathbb{R}^3 $ in order to get a sharper tip.
The {\small\tt apple} manifold is no longer relevant.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Mesh}::Iterator \azul{it} = fisalis .iterator ( \taag::over_vertices );
   for ( it .reset(); it .in_range(); it++ )
   \{  \verm{Cell} \azul{P} = *it;
      x(P) *= \laranja{0.8};  y(P) *= \laranja{0.8};
      if ( z(P) > \laranja{1.3} )
      \{  x(P) /= \laranja{1.} + \laranja{300.} * std::pow ( z(P) - \laranja{1.3}, \laranja{3.} );
         y(P) /= \laranja{1.} + \laranja{300.} * std::pow ( z(P) - \laranja{1.3}, \laranja{3.} );
         z(P) *= \laranja{1.} + \laranja{10.} * ( z(P) - \laranja{1.3} ) * ( z(P) - \laranja{1.3} );  \}
      if ( z(P) > \laranja{0.} ) z(P) *= \laranja{0.8};                             \}
\end{Verbatim}

Paragraph \ref{\numb section 9.\numb parag 5} explains the notion of an iterator over cells of a mesh.

\begin{figure}[ht] \centering
  \includegraphics[width=70mm]{fisalis}
  \caption{meshing a chinese lantern}
  \label{\numb section 2.\numb fig 20}
\end{figure}

We add a sequence of barycenter operations for smoothening the shape.
Note that each barycenter operation is relative to a sector and applies only to inner vertices,
so the boundary of the sector is not changed.
Thus, the eight rims defined in the beginning are kept unchanged.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 16}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   std::vector < \verm{Mesh} > ::iterator \azul{it1};
   for ( it1 = lm .begin(); it1 != lm .end(); it1++ )
   \{  \verm{Mesh} \azul{sect} = *it1;
      \verm{Mesh}::Iterator \azul{it2} = sect .iterator ( \taag::over_vertices );
      for ( int \azul{i} = \laranja{1}; i < \laranja{20}; i++ )
      for ( it2 .reset(); it2 .in_range(); it2++ )
      \{  \verm{Cell} \azul{ver} = *it2;
         if ( ver .is_inner_to ( sect ) )  sect .barycenter ( ver );  \}  \}
\end{Verbatim}

And we are happy with the final result, shown in figure \ref{\numb section 2.\numb fig 20}.

In order to shorten the {\tt C++} code, we could have used loops, in the spirit of
paragraphs \ref{\numb section 9.\numb parag 2} and \ref{\numb section 9.\numb parag 3}.

An animation related to this example is available at\hfil\break
{\small\tt https://maniFEM.rd.ciencias.ulisboa.pt/apple-to-physalis.gif}


          %-----------------------------------%
\section{~~A manifold defined by two equations}\label{\numb section 2.\numb parag 17}
          %-----------------------------------%

We can define a one-dimensional submanifold of $ \mathbb{R}^3 $ by two implicit equations\,:
\medskip

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 17}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{xyz} = RR3 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{x} = xyz[\laranja{0}], \azul{y} = xyz[\laranja{1}], \azul{z} = xyz[\laranja{2}];
   \verm{Manifold} \azul{circle_manifold} = RR3 .implicit ( x*x + y*y == \laranja{1.}, x*y == \laranja{4.}*z );

   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};  y(S) = \laranja{-1.};  z(S) = \laranja{0.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};  z(E) = \laranja{0.};
   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};  z(N) = \laranja{0.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};  z(W) = \laranja{0.};
   \cinza{// these four points already belong to 'circle_manifold', no projection needed}

   \verm{Mesh} \azul{SE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( E ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{EN} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( N ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{NW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( N ) .stop_at ( W ) .divided_in ( \laranja{5} );
   \verm{Mesh} \azul{WS} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( S ) .divided_in ( \laranja{5} );

   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::join ) .meshes ( \{ SE, EN, NW, WS \} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{S}{\small\tt\textcolor{textindraw}{S}}
  \psfrag{N}{\small\tt\textcolor{textindraw}{N}}
  \psfrag{E}{\small\tt\textcolor{textindraw}{E}}
  \psfrag{W}{\small\tt\textcolor{textindraw}{W}}
  \includegraphics[width=90mm]{circle-3d}
  \caption{one-dimensional mesh in $ {\mathbb R}^3 $}
  \label{\numb section 2.\numb fig 21}
\end{figure}

Paragraph \ref{\numb section 3.\numb parag 4} shows another way of meshing the same loop.


          %---------%
\section{~~Exercise}\label{\numb section 2.\numb parag 18}
          %---------%

In paragraph \ref{\numb section 2.\numb parag 15} we have built twelve segments embedded in
two-dimensional manifolds.
This means that, a priori, we do not control precisely the shape of these segments,
they are projections of straight segments onto the respective surface.
Change the code by defining precisely the shape of these segments (defining one-dimensional
manifolds which the segments must follow), while obtaining exactly the same 3d star-like shape.


          %------------------------------%
\section{~~A submanifold of a submanifold}\label{\numb section 2.\numb parag 19}
          %------------------------------%

An implicit manifold has submanifolds.
For instance, we can improve the look of the ``bumpy hemisphere'' in paragraph
\ref{\numb section 2.\numb parag 9} by building its base (a circle-like closed curve)
inside a one-dimensional manifold.
For the rest of the surface, we switch back to the two-dimensional manifold {\small\tt nut}.
The result is shown in figure \ref{\numb section 2.\numb fig 22}.
\medskip

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 19}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{nut} = RR3 .implicit ( x*x + y*y + z*z + \laranja{1.5}*x*y*z == \laranja{1.} );
   int \azul{n} = \laranja{10};

   \cinza{// first build the base (a closed curve)}
   \verm{Manifold} \azul{base} = nut .implicit ( x*x + \laranja{3.}*z == \laranja{0.} );

   \cinza{// define some points :}
   \verm{Cell} \azul{S} ( \taag::vertex );  x(S) =  \laranja{0.};  y(S) = \laranja{-1.};  z(S) =  \laranja{0.};
   \verm{Cell} \azul{E} ( \taag::vertex );  x(E) =  \laranja{1.};  y(E) =  \laranja{0.};  z(E) =  \laranja{0.};
   \verm{Cell} \azul{N} ( \taag::vertex );  x(N) =  \laranja{0.};  y(N) =  \laranja{1.};  z(N) =  \laranja{0.};
   \verm{Cell} \azul{W} ( \taag::vertex );  x(W) = \laranja{-1.};  y(W) =  \laranja{0.};  z(W) =  \laranja{0.};
   \cinza{// no need to project S and N, they are already on 'base'}
   base .project (E);  base .project (W);
   \verm{Cell} \azul{mSW} ( \taag::vertex );  x (mSW) = \laranja{-1.};  y (mSW) = \laranja{-1.};  z (mSW) = \laranja{0.};
   base .project ( mSW );  \cinza{// midway between S and W}
   \cinza{// define similarly mSE, mNE and mNW}

   \cinza{// now build eight segments, forming the base}
   \verm{Mesh} \azul{S_mSW} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( mSW ) .divided_in ( n );
   \verm{Mesh} \azul{S_mSE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( S ) .stop_at ( mSE ) .divided_in ( n );
   \verm{Mesh} \azul{E_mSE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( mSE ) .divided_in ( n );
   \verm{Mesh} \azul{E_mNE} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( E ) .stop_at ( mNE ) .divided_in ( n );
   \cinza{// ... and so forth ...}

   \cinza{// we are done with the base, now switch back to 'nut'}
   nut .set_as_working_manifold();

   \cinza{// more points :}
   \verm{Cell} \azul{up} ( \taag::vertex );  x (up) = \laranja{0.};  y (up) = \laranja{0.};  z (up) = \laranja{1.};
   \cinza{// no need to project 'up', it is already on 'nut'}
   \verm{Cell} \azul{mSup}  ( \taag::vertex );  x (mSup) = \laranja{0.};  y (mSup) = \laranja{-1.};  z (mSup) = \laranja{1.};
   nut .project ( mSup );  \cinza{// midway between S and up}
   \verm{Cell} \azul{mEup}  ( \taag::vertex );  x (mEup) = \laranja{0.};  y (mEup) = \laranja{-1.};  z (mEup) = \laranja{1.};
   nut .project ( mEup );  \cinza{// midway between E and up}
   \cinza{// ... and so forth ...}

   \cinza{// more segments :}
   \verm{Mesh} \azul{W_mWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( W ) .stop_at ( mWup ) .divided_in ( n );
   \verm{Mesh} \azul{mSW_mSWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( mSW ) .stop_at ( mSWup ) .divided_in ( n );
   \verm{Mesh} \azul{mWup_mSWup} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( mWup ) .stop_at ( mSWup ) .divided_in ( n );
   \cinza{// ... and so forth ...}
\end{Verbatim}

\begin{figure}[ht] \centering
  \includegraphics[width=88mm]{bumpy}
  \caption{a helmet}
  \label{\numb section 2.\numb fig 22}
\end{figure}

If we wanted a flat base, we could have defined

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Manifold} \azul{base} = nut .implicit ( z == \laranja{0.} );
\end{Verbatim}

Paragraph \ref{\numb section 3.\numb parag 9} shows a way to mesh the same surface using
fewer lines of code.


          %-------------------------------%
\section{~~Parametric manifolds -- a curve}\label{\numb section 2.\numb parag 20}
          %-------------------------------%

Paragraphs \ref{\numb section 2.\numb parag 6}\,--\,\ref{\numb section 2.\numb parag 19} describe
manifolds defined through implicit equations, that is, level sets in $ \mathbb{R}^2 $ or
$ \mathbb{R}^3 $.
Another way of defining a submanifold is through a parametrization.
Below is an example (the result is shown in figure \ref{\numb section 2.\numb fig 23}).
\vskip 15pt

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 20}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \cinza{// at the beginning, we define 'spiral' as a straight line}
   \verm{Manifold} \azul{spiral} ( \taag::Euclid, \taag::of_dim, \laranja{1} );
   \verm{Function} \azul{t} = spiral .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, 1 );

   \cinza{// now build 'arc_of_spiral' merely as a segment from pi/2 to 5 pi}
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Cell} \azul{A} ( \taag::vertex );  t (A) = pi/\laranja{2.};
   \verm{Cell} \azul{B} ( \taag::vertex );  t (B) = \laranja{5.}*pi;

   \verm{Mesh} \azul{arc_of_spiral} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( 30 );
   \cinza{// not very interesting for now}

   \cinza{// but now define functions x and y as expressions of t :}
   \verm{Function} \azul{x} = t * \verm{cos}(t), \azul{y} = t * \verm{sin}(t);
   \cinza{// and declare them to be the new coordinates}
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dimension, \laranja{2} );
   RR2 .set_coordinates ( x && y );

   \cinza{// in future statements (e.g. for graphical representation)}
   \cinza{// x and y will be used, not t :}
   arc_of_spiral .export_to_file ( \taag::eps, \verde{"spiral.eps"} );
\end{Verbatim}

\begin{figure}[ht] \centering
  \psfrag{A}{\small\tt\textcolor{textindraw}{A}}
  \psfrag{B}{\small\tt\textcolor{textindraw}{B}}
  \includegraphics[width=75mm]{spiral}
  \caption{one-dimensional mesh in $ {\mathbb R}^2 $}
  \label{\numb section 2.\numb fig 23}
\end{figure}

The operator {\small\tt \&\&} joins two functions into one vector-valued function.

Note that, when defining points {\small\tt A} and {\small\tt B}, we only set the value of
{\small\tt t}.
Functions {\small\tt x} and {\small\tt y} are defined later, as arithmetic expressions in terms of
{\small\tt t}; their values will be computed ``on-the-fly'' when needed.
%A parametric manifold has attached to it a function called ``parameter'' and another one called
%``coordinate''.
%Both may be vector functions (may have serveral components).
%The ``coordinates'' are used, for instance, for graphical representation.
%The ``parameter'' or ``parameters'' are used, for instance, for interpolation.
%The {\small\tt\verm{Mesh}} constructors with {\small\tt\taag::segment},
%{\small\tt\taag::quadrangle} or {\small\tt\taag::triangle}
% build new points and define their position in the manifold by
%interpolating the parameters, not the coordinates.
%Unlike for implicit manifolds, no projection is necessary.
In the drawing above, we note that the generated points are not equidistant in the sense of the
Euclidian distance in $ \mathbb{R}^2 $.
They correspond to values of {\small\tt t} which are uniformly distributed between
$ \pi/2 $ (at {\small\tt A}) and $ 5\pi $ (at {\small\tt B}).

The approach described above has the disadvantage that, if we want to subsequently change the
distribution of nodes along the {\small\tt arc\_\,of\_\,spiral}, we must switch back to the original
{\small\tt t} coordinate.

Paragraph \ref{\numb section 3.\numb parag 5} shows another way of meshing a curve,
producing equidistant vertices.


          %----------------%
\section{~~Closing a circle}\label{\numb section 2.\numb parag 21}
          %----------------%

In the approach of paragraph \ref{\numb section 2.\numb parag 20}, it is possible but cumbersome to
build a closed curve\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 21}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{circle_manif} ( \taag::Euclid, \taag::of_dim, \laranja{1} );
   \verm{Function} \azul{t} = circle_manif .build_coordinate_system
                ( \taag::Lagrange, \taag::of_degree, \laranja{1} );

   \cinza{// build 'circle' merely as a segment from 0 to 1.9 pi}
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Cell} \azul{A} ( \taag::vertex );  t(A) =  \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  t(B) =  \laranja{1.9}*pi;
   \verm{Mesh} \azul{incomplete_circle} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{19} );

   \cinza{// now close the curve in a not very elegant manner}
   \verm{Mesh} \azul{small_piece} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( A ) .divided_in ( \laranja{1} );
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::join )
      .meshes ( \{ incomplete_circle, small_piece \} );

   \cinza{// define new coordinates x and y as expressions of t :}
   \verm{Function} \azul{x} = \verm{cos}(t), \azul{y} = \verm{sin}(t);
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dimension, \laranja{2} );
   RR2 .set_coordinates ( x && y );

   \cinza{// in future statements (e.g. for graphical representation)}
   \cinza{// x and y will be used, not t :}
   circle .export_to_file ( \taag::eps, \verde{"circle.eps"} );
\end{Verbatim}

Rather than declaring {\small\tt\azul{small\_\,piece}} as a {\small\tt\verm{Mesh}}
(made of one cell only), we may treat it as a {\small\tt\verm{Cell}}\,:

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{19} );
   \verm{Cell} \azul{small_piece} ( \taag::segment, B .reverse(), A );
   small_piece .add_to ( circle );
\end{Verbatim}

Paragraph \ref{\numb section 7.\numb parag 2} shows a more elegant way to close a curve in itself.

On the other hand, if we only want a visual illusion of a closed circle, we may use the code below.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,baselinestretch=0.94]
   \verm{Manifold} \azul{circle_manif} ( \taag::Euclid, \taag::of_dim, \laranja{1} );
   \verm{Function} \azul{t} = circle_manif .build_coordinate_system
      ( \taag::Lagrange, \taag::of_degree, \laranja{1} );

   \cinza{// build 'circle' merely as a segment from 0 to 2 pi}
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Cell} \azul{A} ( \taag::vertex );  t (A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  t (B) = \laranja{2.}*pi;
   \verm{Mesh} \azul{circle} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{20} );
   \cinza{// gives the illusion of a closed circle}

   \cinza{// define new coordinates x and y as expressions of t :}
   \verm{Function} \azul{x} = \verm{cos}(t), \azul{y} = \verm{sin}(t);
   \verm{Manifold} \azul{RR2} ( \taag::Euclid, \taag::of_dimension, \laranja{2} );
   RR2 .set_coordinates ( x && y );
\end{Verbatim}


          %---------------------------------%
\section{~~Parametric manifolds -- a surface}\label{\numb section 2.\numb parag 22}
          %---------------------------------%

Here is an example of a parametrized surface\,:

\begin{figure}[hb] \centering
  \includegraphics[width=95mm]{torus}
  \caption{incomplete torus}
  \label{\numb section 2.\numb fig 24}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 22}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{torus} ( \taag::Euclid, \taag::of_dim, \laranja{2} );
   \verm{Function} \azul{alpha_beta} =
      torus .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \cinza{// extract components of alpha_beta :}
   \verm{Function} \azul{alpha} = alpha_beta [\laranja{0}], \azul{beta} = alpha_beta [\laranja{1}];
   \cinza{// build a rectangle in the alpha-beta plane}
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Cell} \azul{A} ( \taag::vertex );  alpha (A) = \laranja{0.};       beta (A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  alpha (B) = \laranja{0.};       beta (B) = \laranja{1.9}*pi;
   \verm{Cell} \azul{C} ( \taag::vertex );  alpha (C) = \laranja{1.95}*pi;  beta (C) = \laranja{1.9}*pi;
   \verm{Cell} \azul{D} ( \taag::vertex );  alpha (D) = \laranja{1.95}*pi;  beta (D) = \laranja{0.};
   \cinza{// four almost-closed circles :}
   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{19} );
   \verm{Mesh} \azul{BC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( C ) .divided_in ( \laranja{39} );
   \verm{Mesh} \azul{CD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( D ) .divided_in ( \laranja{19} );
   \verm{Mesh} \azul{DA} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( D ) .stop_at ( A ) .divided_in ( \laranja{39} );

   \verm{Mesh} \azul{ABCD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::rectangle )
      .faces ( AB, BC, CD, DA );  \cinza{// an almost-closed torus}
   
   \cinza{// parametrize the torus}
   const double \azul{big_radius} = \laranja{3.}, \azul{small_radius} = \laranja{1.};
   \verm{Function} \azul{x} = ( big_radius + small_radius * \verm{cos}(beta) ) * \verm{cos}(alpha),
            \azul{y} = ( big_radius + small_radius * \verm{cos}(beta) ) * \verm{sin}(alpha),
            \azul{z} = small_radius * \verm{sin}(beta);

   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dimension, \laranja{3} );
   RR3 .set_coordinates ( x && y && z );  \cinza{// forget about alpha and beta}

   \cinza{// in future statements (e.g. for graphical representation)}
   \cinza{// x, y and z will be used, not alpha nor beta :}
   ABCD .export_to_file ( \taag::gmsh, \verde{"torus.msh"} );
\end{Verbatim}

Closing the torus in the cumbersome manner shown in paragraph
\ref{\numb section 2.\numb parag 21} is possible but not practical.
Paragraphs \ref{\numb section 5.\numb parag 4}, \ref{\numb section 5.\numb parag 5} and
\ref{\numb section 7.\numb parag 5} show other, more elegant, solutions.

If we only want a visual illusion of a closed surface, we may change the numerical values,
in the spirit of the code at the end of paragraph \ref{\numb section 2.\numb parag 21}.


          %-------------------%
\section{~~A cylindrical shell}\label{\numb section 2.\numb parag 23}
          %-------------------%

The approach described in paragraph \ref{\numb section 2.\numb parag 22} can be used to
build extruded shapes\,:

\begin{figure}[ht] \centering
  \includegraphics[width=95mm]{cylind-shell}
  \caption{cylindrical shell}
  \label{\numb section 2.\numb fig 25}
\end{figure}

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 23}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR3_param} ( \taag::Euclid, \taag::of_dim, \laranja{3} );
   \verm{Function} \azul{zrt} =
      RR3_param .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \verm{Function} \azul{z} = zrt [\laranja{0}], \azul{r} = zrt [\laranja{1}], \azul{theta} = zrt [\laranja{2}];

   \verm{Cell} \azul{A} ( \taag::vertex );  r(A) = \laranja{1.} ;  theta(A) = \laranja{0.};  z(A) = \laranja{-1}.;
   \verm{Cell} \azul{B} ( \taag::vertex );  r(B) = \laranja{1.2};  theta(B) = \laranja{0.};  z(B) = \laranja{-1}.;
   \cinza{// ... six more vertices ...}

   \verm{Mesh} \azul{shell} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::cube )
      .vertices ( A, B, C, D, E, F, G, H ) .divided_in ( \laranja{5}, \laranja{15}, \laranja{15} );

   \verm{Function} \azul{x} = r * \verm{cos}(theta), \azul{y} = r * \verm{sin}(theta);
   \verm{Manifold} \azul{RR3} ( \taag::Euclid, \taag::of_dimension, \laranja{3} );
   RR3 .set_coordinates ( x && y && z );  \cinza{// forget about r and theta}

   shell .export_to_file ( \taag::gmsh, \verde{"shell.msh"} );
\end{Verbatim}

Section \ref{\numb section 4} describes how to directly extrude shapes in \maniFEM.


          %-----------------------------------------%
\section{~~Starting with a high-dimensional manifold}\label{\numb section 2.\numb parag 24}
          %-----------------------------------------%

Instead of starting with a manifold having only the parameter(s), we may start with a
high-dimensional manifold containing both the geometric coordinates and the parameter(s),
then define the parametrization through equation(s).
% The advantage of this approach is that we can later shwitch on and off a constraint,
% thus switching between meshes of different dimensions.
There is a disadvantage however, regarding performance\,: {\maniFEM} will reserve,
for each vertex, space in the computer's memory for five {\small\tt double} values.

\begin{Verbatim}[commandchars=\\\{\},formatcom=\small\tt,frame=single,
   label=parag-\ref{\numb section 2.\numb parag 24}.cpp,rulecolor=\color{moldura},
   baselinestretch=0.94,framesep=2mm                                              ]
   \verm{Manifold} \azul{RR5} ( \taag::Euclid, \taag::of_dim, \laranja{5} );
   \verm{Function} \azul{xyzab} = RR5 .build_coordinate_system ( \taag::Lagrange, \taag::of_degree, \laranja{1} );
   \cinza{// extract components of xyzab :}
   \verm{Function} \azul{x} = xyzab [\laranja{0}], \azul{y} = xyzab [\laranja{1}], \azul{z} = xyzab [\laranja{2}],
            \azul{alpha} = xyzab [\laranja{3}], \azul{beta} = xyzab [\laranja{4}];

   \cinza{// define a torus as a submanifold of RR5 :}
   const double \azul{big_radius} = \laranja{3}, \azul{small_radius} = \laranja{1};
   \verm{Manifold} \azul{torus} = RR5 .parametric
      ( x == ( big_radius + small_radius * \verm{cos}(beta) ) * \verm{cos}(alpha),
        y == ( big_radius + small_radius * \verm{cos}(beta) ) * \verm{sin}(alpha),
        z == small_radius * \verm{sin}(beta)                               );
   \cinza{// define four corners :}
   const double \azul{pi} = \laranja{3.1415926536};
   \verm{Cell} \azul{A} ( \taag::vertex );  alpha (A) = \laranja{0.};       beta (A) = \laranja{0.};
   \verm{Cell} \azul{B} ( \taag::vertex );  alpha (B) = \laranja{0.};       beta (B) = \laranja{1.9}*pi;
   \verm{Cell} \azul{C} ( \taag::vertex );  alpha (C) = \laranja{1.95}*pi;  beta (C) = \laranja{1.9}*pi;
   \verm{Cell} \azul{D} ( \taag::vertex );  alpha (D) = \laranja{1.95}*pi;  beta (D) = \laranja{0.};
   torus .project (A);   torus .project (B);  \cinza{// the projection operation computes}
   torus .project (C);   torus .project (D);  \cinza{// coordinates x, y and z of each vertex}

   \cinza{// four almost-closed circles :}
   \verm{Mesh} \azul{AB} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( A ) .stop_at ( B ) .divided_in ( \laranja{19} );
   \verm{Mesh} \azul{BC} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( B ) .stop_at ( C ) .divided_in ( \laranja{39} );
   \verm{Mesh} \azul{CD} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( C ) .stop_at ( D ) .divided_in ( \laranja{19} );
   \verm{Mesh} \azul{DA} = \verm{Mesh}::Build ( \taag::grid ) .shape ( \taag::segment )
      .start_at ( D ) .stop_at ( A ) .divided_in ( \laranja{39} );

   \cinza{// build a rectangle}
   \verm{Mesh} \azul{ABCD} ( \taag::rectangle, AB, BC, CD, DA );  \cinza{// an almost-closed torus}
   \cinza{// internally, each newly built vertex is projected on the current working manifold}
   \cinza{// thus, the coordinates x, y and z of that vertex are updated}
\end{Verbatim}
%
%   ABCD .export_to_file ( \taag::gmsh, \verde{"torus.msh"} );

The {\small\tt\verm{Manifold}::parametric} method is similar to {\small\tt\verm{Manifold}::implicit},
presented in paragraphs \ref{\numb section 2.\numb parag 6}\,--\,%
\ref{\numb section 2.\numb parag 19}.
The only difference is that by using {\small\tt parametric} we declare an explicit dependence\,%
\footnote{{} Perhaps {\footnotesize\tt explicit} would be a better name than
{\footnotesize\tt parametric}; unfortunately, that word is reserved in {\small\tt C++}.}
of the coordinates (here, {\small\tt x}, {\small\tt y} and {\small\tt z}) upon the parameters
(here, {\small\tt alpha} and {\small\tt beta}).
This endows the manifold {\small\tt torus} with a different projection operator.
The projection of a vertex from {\small\tt RR5} onto {\small\tt torus} is done by merely updating
the values of {\small\tt x}, {\small\tt y} and {\small\tt z}, while keeping {\small\tt alpha} and
{\small\tt beta} constant.

{\small\tt\verm{Mesh}::Build}\,ers with {\small\tt.shape} of {\small\tt\taag::segment},
{\small\tt\taag::triangle} and {\small\tt\taag::rectangle},
when building each new vertex, interpolate the coordinates {\small\tt alpha} and
{\small\tt beta} using several vertices from the boundary, then project the vertex,
thus updating the values of {\small\tt x}, {\small\tt y} and {\small\tt z}.
On the other hand, method {\small\tt\verm{Mesh}::export\_\,to\_\,file}
uses only coordinates {\small\tt x}, {\small\tt y} and {\small\tt z}.
